Bug 1069882 - Review Request: python-ironicclient - Ironic client for Openstack
Review Request: python-ironicclient - Ironic client for Openstack
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Steven Dake
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-02-25 15:48 EST by Angus Thomas
Modified: 2016-04-26 12:21 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-04-01 21:20:31 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sdake: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Angus Thomas 2014-02-25 15:48:58 EST
Spec URL: https://github.com/agroup/tripleo-rpm-spec-files/blob/master/ironicclient/python-ironicclient.spec
SRPM URL: http://athomas.fedorapeople.org/ironic/fedora20/python-ironicclient-0.1.2-1.fc20.src.rpm
Description: Python client for Ironic
Fedora Account System Username: athomas
Comment 1 Matthias Runge 2014-02-26 10:49:19 EST
I'd
Comment 2 Steven Dake 2014-02-26 11:54:58 EST
Angus,

I'll sponsor you.

Please have a quick read:
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers

Let me know when you have completed this step.
Comment 3 Steven Dake 2014-02-26 13:30:17 EST
Couple notes:

1) Recommend changing the source URL to the openstack tarball location:
http://tarballs.openstack.org/python-ironicclient/python-ironicclient-0.1.2.tar.gz

2) I would recommend adding a build requires for python-setuptools

I would recommend removing:
rm -rf python_ironicclient.egg-info

2.a) I believe the egg-info is needed

# Let RPM handle deps
sed -i '/setup_requires/d; /install_requires/d; /dependency_links/d' setup.py
2.b) hacking setup.py via sed is evil and prone to breakage


# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
rm -rf {test-,}requirements.txt

2.c) removing upstream files to hack around pbr dependencies not wanted in the runtime can be fixed in other ways

And instead handle that with patches.  Take a look at how other python clients are done for OpenStack.  Its pretty straight forward.  (fedpkg clone python-novaclient for example)

3) You don't need to remove the buildroot
rm -rf %{buildroot}%{python2_sitelib}/python_ironicclient*

Otherwise looks pretty good.  After these issues are fixed up, I'll provide a complete review.
Comment 4 Angus Thomas 2014-02-27 07:01:19 EST
Hi Steve,

I've read through the package maintainer's docs, and built an updated package, based on your feedback so far.

Spec URL: https://github.com/agroup/tripleo-rpm-spec-files/blob/master/ironicclient/python-ironicclient.spec
SRPM URL: http://athomas.fedorapeople.org/ironic/fedora20/python-ironicclient-0.1.2-2.fc20.src.rpm

Thanks,

Angus
Comment 5 Angus Thomas 2014-02-27 07:52:58 EST
Another update, adding support for %{__python2} and %{python2_sitelib} on EL6.

Spec URL: https://github.com/agroup/tripleo-rpm-spec-files/blob/master/ironicclient/python-ironicclient.spec

SRPM URL: http://athomas.fedorapeople.org/ironic/fedora20/python-ironicclient-0.1.2-3.fc20.src.rpm


Angus
Comment 6 Steven Dake 2014-02-27 09:54:48 EST
Angus,

Couple things

First your patches are directory diffs, which is ok, but IMO it makes more sense to do the following:

clone a copy of the ironicclient.

Apply the 0001 patch
git commit -a
(Write a nice changelog)

Apply the 0002 patch
git commit -a
write a nice changelog

git format-patch -2

This will give you a tidy changelog in the patches and allow people to use git am to apply the patches.

The first patch will look at the variable:
REDHATIRONICCLIENTVERSION

I believe this needs to be sed-ed into the file as is done in the nova client spec file.  I recently did this for one of the os-*-* tools and it was necessary to do the sed, or the installed package doesn't work.

The requirements for removing the pbr runtime requirement come from the openstack fedora developers - this is not something a typical python packager would do, so keep that in mind during further reviews of other people's packages.

Just one minor nitpick as well, typically %doc goes at the top of the files section.  Although this is not mandatory or documented, it is a typical common convention and since you need to remake packages, it might not hurt to fix that up.

Regards
-steve
Comment 7 Angus Thomas 2014-02-27 12:33:17 EST
Thanks Steve

I've posted a new version, taking account of your latest comments:

Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/ironicclient/python-ironicclient.spec

SRPM URL: http://athomas.fedorapeople.org/ironic/fedora20/python-ironicclient-0.1.2-4.fc20.src.rpm
Comment 8 Steven Dake 2014-03-18 14:03:13 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache (v2.0)".
     3 files have unknown license. Detailed output of licensecheck in
     /home/sdake/fedora-review/1069882-python-ironicclient/licensecheck.txt

The following files have no copyright header.  Since the package license is clear, these aren't clear problems, but it would make sense to file an upstream bug to add a license header on these files:

python-ironicclient-0.1.2/ironicclient/client.py
python-ironicclient-0.1.2/ironicclient/exc.py
python-ironicclient-0.1.2/ironicclient/shell.py
python-ironicclient-0.1.2/ironicclient/tests/test_client.py
python-ironicclient-0.1.2/ironicclient/tests/test_shell.py
python-ironicclient-0.1.2/ironicclient/v1/shell.py

The following are generated by the build and no license changes are necessary
python-ironicclient-0.1.2/doc/source/conf.py
python-ironicclient-0.1.2/setup.py
python-ironicclient-0.1.2/tools/with_venv.sh

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-ironicclient-0.1.2-4.fc20.noarch.rpm
          python-ironicclient-0.1.2-4.fc20.src.rpm
python-ironicclient.noarch: E: explicit-lib-dependency python-httplib2
python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/node_shell.py 0644L /usr/bin/env
python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/port_shell.py 0644L /usr/bin/env
python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/chassis_shell.py 0644L /usr/bin/env
python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/__init__.py 0644L /usr/bin/env
python-ironicclient.noarch: W: no-manual-page-for-binary ironic
python-ironicclient.src:64: W: macro-in-%changelog %files

Don't use macros in changelogs.  just change %files to files.

python-ironicclient.src:16: W: mixed-use-of-spaces-and-tabs (spaces: line 7, tab: line 16)

please correct to use either tabs or spaces entirely.  I'd recommend tabs.

2 packages and 0 specfiles checked; 5 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-ironicclient
python-ironicclient.noarch: E: explicit-lib-dependency python-httplib2


this is a false negative error.  rpm doesn't handle explicit lib dependencies for python packages.

python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/node_shell.py 0644L /usr/bin/env

recommend filing a bug with upstream to remove /usr/bin/env.  Since this is a library, I am pretty sure the need to specify the environment is not necessaary.

python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/port_shell.py 0644L /usr/bin/env

recommend filing a bug with upstream to remove /usr/bin/env.  Since this is a library, I am pretty sure the need to specify the environment is not necessaary.

python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/chassis_shell.py 0644L /usr/bin/env

recommend filing a bug with upstream to remove /usr/bin/env.  Since this is a library, I am pretty sure the need to specify the environment is not necessaary.

python-ironicclient.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/ironicclient/v1/__init__.py 0644L /usr/bin/env

recommend filing a bug with upstream to remove /usr/bin/env.  Since this is a library, I am pretty sure the need to specify the environment is not necessaary.

python-ironicclient.noarch: W: no-manual-page-for-binary ironic
1 packages and 0 specfiles checked; 5 errors, 1 warnings.
# echo 'rpmlint-done:'
Requires
--------
python-ironicclient (rpmlib, GLIBC filtered):
    /usr/bin/python2
    python(abi)
    python-anyjson
    python-httplib2
    python-keystoneclient
    python-lxml
    python-prettytable
    python-six
    python-stevedore



Provides
--------
python-ironicclient:
    python-ironicclient



Source checksums
----------------
http://tarballs.openstack.org/python-ironicclient/python-ironicclient-0.1.2.tar.gz :
  CHECKSUM(SHA256) this package     : bcaf73c8f28e8fbe28eca588eed7bcfa8aa76531a510e904deccf6f6c3d7f28d
  CHECKSUM(SHA256) upstream package : bcaf73c8f28e8fbe28eca588eed7bcfa8aa76531a510e904deccf6f6c3d7f28d


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1069882
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 9 Steven Dake 2014-03-18 14:05:25 EDT
Angus,

Package is looking pretty good.  Things blocking approval:
1. use of %files in changelog (just change to "files section"
2. mixed use of tabs and spaces in spec file

Things not blocking review:
1. Recommend filing upstream bugs to remove /usr/bin/env from library files as indicated in Comment #8.
2. Recommend filing upstream bugs to add license headers to files as indicated in Comment #8.

Regards,
-steve
Comment 10 Angus Thomas 2014-03-26 09:40:14 EDT
Thanks Steve

I've posted a new version, taking account of your latest comments:

Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/ironicclient/python-ironicclient.spec

SRPM URL: http://athomas.fedorapeople.org/ironic/fedora20/python-ironicclient-0.1.2-5.fc20.src.rpm

I've addressed the blocking items from Comment 9. I'll push patches upstream for the non-blocking items, though they may not be merged until the Juno dev cycle.



Angus
Comment 11 Steven Dake 2014-03-26 09:46:52 EDT
Angus,

re Juno dev cycle and patches, that is fine - idea is to get upstream to fix them at some point, doesn't have to happen immediately.

New spec looks good.
Comment 12 Steven Dake 2014-03-26 09:47:21 EDT
Comment #10 package APPROVED.
Comment 13 Steven Dake 2014-03-26 09:50:51 EDT
Angus,

Welcome to the packager's group!  Do well with your new found abilities :)

Please submit a SCM request for this particular review:

http://fedoraproject.org/wiki/Package_SCM_admin_requests
Comment 14 Angus Thomas 2014-03-27 09:22:15 EDT
New Package SCM Request
=======================
Package Name: python-ironicclient
Short Description: A python and command line client library for Ironic
Owners: athomas
Branches: f20
InitialCC:
Comment 15 Gwyn Ciesla 2014-03-27 09:47:46 EDT
Review flag should be set to + by the reviewer.
Comment 16 Angus Thomas 2014-03-28 07:42:22 EDT
New Package SCM Request
=======================
Package Name: python-ironicclient
Short Description: A python and command line client library for Ironic
Owners: athomas
Branches: f20
InitialCC:
Comment 17 Gwyn Ciesla 2014-03-28 08:48:37 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.